<template>
  <div>
    <div id="game-container">
      <div v-if="!game" class="start-button button" @click="start">Start</div>
      <div v-if="game" class="question-container">
        <div class="question">
          Type (or click) the capital letter that matches:
        </div>
        <letter :letter="letter"></letter>
        <options :letters="letters" :answer="letter"></options>
        <div v-if="game" class="exit-button button" @click="game = false">Exit</div>
      </div>
    </div>
    <div v-if="win" class="winner">
      <div class="winner-text">YOU WIN!</div>
      <div @click="again" class="winner-button button">Again?</div>
    </div>
  </div>
</template>

<script>
import Letter from '~/components/Letter'
import Options from '~/components/Options'

import { mapState, mapActions } from 'vuex'

export default {
  components: {
    Letter,
    Options
  },
  data() {
    return {
      game: false,
      alphabet: 'abcdefghijklmnopqrstuvwxyz',
      letter: '',
      letters: ['', '', '']
    }
  },
  methods: {
    start() {
      this.game = true
      this.letter = this.alphabet[Math.floor(Math.random() * 26)]
      this.letters = [
        this.letter.toUpperCase(),
        this.alphabet[Math.floor(Math.random() * 26)].toUpperCase(),
        this.alphabet[Math.floor(Math.random() * 26)].toUpperCase()
      ]
      this.letters = this.shuffle(this.letters)
    },
    shuffle(a) {
      for (let i = a.length - 1; i > 0; i--) {
        const j = Math.floor(Math.random() * (i + 1))
        ;[a[i], a[j]] = [a[j], a[i]]
      }
      return a
    },
    again() {
      this.game = false
      this.resetGuess()
      this.wrong()
      this.start()
    },
    ...mapActions(['wrong', 'resetGuess'])
  },
  computed: {
    ...mapState(['win'])
  },
  watch: {
    win: function() {
      if (this.win === true) {
        document.getElementById('game-container').className = 'blur'
      } else {
        document.getElementById('game-container').className = ''
      }
    }
  }
}
</script>

<style>
.winner {
  position: absolute;
  left: 50%;
  transform: translate(-50%, 0);
  width: 600px;
  height: 400px;
  border-radius: 50px;
  background-color: rgba(49, 157, 49, 0.715);
  top: calc(50vh - 200px);
  display: flex;
  flex-direction: column;
  justify-content: center;
  align-items: center;
}

.winner-button {
  width: 150px;
  height: 100px;
  border-radius: 10px;
  font-size: 60px;
  background-color: rgb(255, 176, 58);
  margin: 20px;
}

.winner-text {
  font-size: 100px;
  font-weight: 900;
  margin: 20px;
}

.blur {
  filter: blur(4px);
}

#game-container {
  display: flex;
  justify-content: center;
  align-items: center;
  height: 100%;
  width: 100%;
}

.question-container {
  width: 100%;
  display: flex;
  flex-direction: column;
  justify-content: center;
  align-items: center;
}

.question {
  display: flex;
  width: 80vw;
  justify-content: center;
  align-items: center;
  text-align: center;
  font-size: 50px;
  margin: 50px;
}

.button {
  display: flex;
  justify-content: center;
  align-items: center;
  cursor: pointer;
  box-shadow: 2px 2px 2px rgba(0, 0, 0, 0.3);
}

.start-button {
  width: 200px;
  height: 100px;
  border-radius: 20px;
  background-color: rgb(94, 174, 94);
}

.exit-button {
  width: 100px;
  height: 50px;
  border-radius: 10px;
  font-size: 40px;
  background-color: rgb(174, 94, 94);
}

.button:hover {
  opacity: 0.7;
}

.start-button:active {
  transform: translateX(2px) translateY(2px);
  box-shadow: 0 0;
}

@media screen and (max-width: 1000px) {
  .question {
    font-size: 40px;
    margin: 10px;
  }
}
</style>